//+------------------------------------------------------------------------------------------------------------+
//|                                                                                    ZH_All_Quotings 4.10912 |
//|                                                                                    Copyright  Zhunko      |
//| 06.04.2011 - 05.02.2014                                                            vadim@zhunko.ru         |
//+------------------------------------------------------------------------------------------------------------+
//|      .                                              |
//| glAQ_TF_M1_M5_ -     .        |
//|                   .                  |
//|                   .              |
//|                   : glAQ_TF_ALL.     ,     |
//|                          .             |
//|                    .                                                    |
//+------------------------------------------------------------------------------------------------------------+
//| 1.  ZH_All_Quotings 4.10425  25.04.2011.                                                       |
//| 1.1.           .      |
//| 1.  ZH_All_Quotings 4.10912  12.09.2011.                                                       |
//| 1.1.        .           |
//|           .                                                 |
//+------------------------------------------------------------------------------------------------------------+
#property copyright "Copyright  Zhunko"
#property link      "vadim@zhunko.ru"
#property strict
#include <ServicesMT.mqh>
int abScanTF[9] = {1}; //     .
//
void OnStart()
 {
  int    i = 0;
  int    nBarsStart = 0; //       .
  int    nBars = 0;      //    .
  int    nStart = 0;     //   .
  string sProgress = ""; // .
  //          "glAQ_TF_..._".
  SwitchPeriod(abScanTF);
  //   ,         .
  nStart = ServiceLoaderQuotesW(MLQ_CONTINUED,       //   :
                                                     //   MLQ_STOP_TF              
                                                     //                        "bMode";
                                                     //   MLQ_CONTINUED       ;
                                                     //   MLQ_FINISH       .
                                true,                //   :
                                                     //   TRUE  -        ;
                                                     //   FALSE -        .
                                abScanTF,            //     .       9 .
                                WindowExpertName()); //  -             .
  for (i = 1, nBarsStart = Bars, sProgress = " "; nStart >= 1 && !IsStopped(); sProgress = sProgress + ">", i++)
   {//    :
    // 1.        .
    if (nBars == Bars)
     {
      ServiceSensorLoadQuotes(WindowHandle(Symbol(), 0));
      return;
     }
    // 2.        .
/*    ServiceLoaderQuotesW(nBars != Bars, NULL, abScanTF, NULL);
    if (nBars == Bars) return;*/
    for (nBars = Bars; i % 10 != 0 && !IsStopped(); sProgress = sProgress + ">", i++)
     {
      RefreshRates();
      Comment("Bars = ", Bars - nBarsStart, "\n", sProgress);
      Sleep(200);
     }
    if (i % 30 == 0) sProgress = "";
   }
 }
//
void deinit()
 {//         .       "start()".
  //      ,   .       .
  if (UninitializeReason() == REASON_REMOVE) ServiceLoaderQuotesW(MLQ_FINISH, NULL, abScanTF, NULL);
 }
//
//     .
void SwitchPeriod(int& abSwitchPeriod[])
 {
  int    j = 0, l = 0;
  string sTimeFrame = ""; //     .
  //----
  ArrayInitialize(abSwitchPeriod, false);                        //  .
  for (j = 0; j < GlobalVariablesTotal() && !IsStopped(); j++)   //    "glAQ_TF_...".
   {
    if (StringSubstr(GlobalVariableName(j), 0, 8) == "glAQ_TF_") //       .
     {
      sTimeFrame = GlobalVariableName(j); //       .
      break;                              //       .
     }
   }
  //     ,   .
  if (j == GlobalVariablesTotal())
   {
    ArrayInitialize(abSwitchPeriod, true);
    return;
   }
  //     .
  if (GlobalVariableGet(sTimeFrame) > 0) //    ,           .
   {
    switch (int(GlobalVariableGet(sTimeFrame)))
     {
      case 9: abSwitchPeriod[8] = true;
      case 8: abSwitchPeriod[7] = true;
      case 7: abSwitchPeriod[6] = true;
      case 6: abSwitchPeriod[5] = true;
      case 5: abSwitchPeriod[4] = true;
      case 4: abSwitchPeriod[3] = true;
      case 3: abSwitchPeriod[2] = true;
      case 2: abSwitchPeriod[1] = true;
      case 1: abSwitchPeriod[0] = true; break;
      default: ArrayInitialize(abSwitchPeriod, true); //   10      .
     }
    return;
   }
  //          "ALL",    .
  if (StringLen(sTimeFrame) <= 8 || sTimeFrame == "" || StringFind(sTimeFrame, "ALL", 7) > 7)
   {
    ArrayInitialize(abSwitchPeriod, true);
    return;
   }
  //     ,         .
  if (StringFind(sTimeFrame,  "M1_", 7) > 7) abSwitchPeriod[0] = true;
  if (StringFind(sTimeFrame,  "M5_", 7) > 7) abSwitchPeriod[1] = true;
  if (StringFind(sTimeFrame, "M15_", 7) > 7) abSwitchPeriod[2] = true;
  if (StringFind(sTimeFrame, "M30_", 7) > 7) abSwitchPeriod[3] = true;
  if (StringFind(sTimeFrame,  "H1_", 7) > 7) abSwitchPeriod[4] = true;
  if (StringFind(sTimeFrame,  "H4_", 7) > 7) abSwitchPeriod[5] = true;
  if (StringFind(sTimeFrame,  "D1_", 7) > 7) abSwitchPeriod[6] = true;
  if (StringFind(sTimeFrame,  "W1_", 7) > 7) abSwitchPeriod[7] = true;
  if (StringFind(sTimeFrame, "MN1_", 7) > 7) abSwitchPeriod[8] = true;
 }
//